varSelect <- function(domain){
  selectedDomain <- domain
  var_list_in_domain <- data_dict[data_dict['Grouping']==domain_dict[selectedDomain], 'Variable']
  selectInput("selected_var_viz", label='Choose a variable:', 
              choices=var_list_in_domain, selected=var_list_in_domain[1])
}

plotBarPreDM2 <- function(inputVar){
  selectedVar <- inputVar$selected_var_viz
  print('selected')
  if(!is.null(selectedVar)){
    # print(selectedVar)
    # varInCSV <- data_dict$Variable[data_dict$VariableName == selectedVar]
    selected_vars <- na.omit(nhanes_data[,c(outcome_name, selectedVar)])
    
    varType <- data_dict$Type[data_dict$Variable == selectedVar]
    # label_vec <- c("Count: ", ..count.., "\nPercentage:", ..count../tapply(..count.., ..fill.., sum)[..fill..])
    # melted_df <- melt(selected_vars)
    # density_by_group_formula = as.formula("..count../tapply(..count.., ..fill.., sum)[..fill..]")
    if ((varType == "Continuous")){
      fig <- ggplot(selected_vars, aes_string(fill=outcome_name, x=selectedVar)) +
        geom_histogram(aes(y=..count../tapply(..count.., ..fill.., sum)[..fill..],
                           text=paste0("Count: ",..count..)), 
                       position="dodge", bins=20) + 
        
        ylab("Percentage") + 
        scale_y_continuous(labels = scales::percent)
      
    }else{
      # selected_vars <- na.omit(selected_vars)
      # selected_vars[[selectedVar]] <- as.factor(selected_vars[[selectedVar]])
      # 
      cat_order <- c()
      if (varType == "Binary"){
        selected_vars[[selectedVar]][selected_vars[[selectedVar]] == "1"] <- "No"
        selected_vars[[selectedVar]][selected_vars[[selectedVar]] == "2"] <- "Yes"
      }else{
        for(n in names(value_mapping_json[[selectedVar]])){
          selected_vars[[selectedVar]][selected_vars[[selectedVar]] == n] <- value_mapping_json[[selectedVar]][[n]]
          cat_order <- append(cat_order, value_mapping_json[[selectedVar]][[n]])
        }
      }
      fig <- ggplot(selected_vars, 
                    aes_string(fill=outcome_name, x=selectedVar)) +
        geom_bar(aes(y=..count../tapply(..count.., ..fill.., sum)[..fill..],
                     text=paste0("Count: ",..count..)), 
                 position="dodge", stat="count") + 
        # geom_text(aes(y=..count../tapply(..count.., ..fill.., sum)[..fill..]
        #               label=''),
        # stat="count") + 
        
        ylab("Percentage") + 
        scale_y_continuous(labels = scales::percent) +
        scale_x_discrete(limits = cat_order)
    }
    # TODO: Change annotation
    # ggplotly(fig, tooltip=c("x", "fill"))
    fig <- fig + scale_fill_manual(breaks=c("Yes", "No"),
                                   values = c("#F8766D", "#00C1AA"))
    ggplotly(fig, tooltip=c("x", "fill", "text"))
  }
}